package com.sun.xml.internal.ws.addressing.v200408;

import javax.xml.namespace.QName;
import javax.xml.ws.WebServiceException;
import org.w3c.dom.Element;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import com.sun.xml.internal.ws.api.WSBinding;
import com.sun.xml.internal.ws.api.model.SEIModel;
import com.sun.xml.internal.ws.api.model.wsdl.WSDLPort;
import javax.xml.bind.JAXBContext;
import com.sun.xml.internal.ws.addressing.WsaTubeHelper;

public class WsaTubeHelperImpl extends WsaTubeHelper
{
    static final JAXBContext jc;
    
    public WsaTubeHelperImpl(WSDLPort wsdlPort, SEIModel seiModel, WSBinding binding) {
        super(binding, seiModel, wsdlPort);
    }
    
    private Marshaller createMarshaller() throws JAXBException {
        Marshaller marshaller = WsaTubeHelperImpl.jc.createMarshaller();
        marshaller.setProperty("jaxb.fragment", Boolean.TRUE);
        return marshaller;
    }
    
    public final void getProblemActionDetail(String action, Element element) {
        ProblemAction pa = new ProblemAction(action);
        try {
            this.createMarshaller().marshal(pa, element);
        }
        catch (JAXBException e) {
            throw new WebServiceException(e);
        }
    }
    
    public final void getInvalidMapDetail(QName name, Element element) {
        ProblemHeaderQName phq = new ProblemHeaderQName(name);
        try {
            this.createMarshaller().marshal(phq, element);
        }
        catch (JAXBException e) {
            throw new WebServiceException(e);
        }
    }
    
    public final void getMapRequiredDetail(QName name, Element element) {
        this.getInvalidMapDetail(name, element);
    }
    
    static {
        try {
            jc = JAXBContext.newInstance(new Class[] { ProblemAction.class, ProblemHeaderQName.class });
        }
        catch (JAXBException e) {
            throw new WebServiceException(e);
        }
    }
}
